//Explosion
datablock ExplosionData(swingableSwordExplosion)
{
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = swordExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 0.2 0.6";
   lightEndColor = "0 0 0";
};
datablock ProjectileData(swingableSwordExplosionProjectile)
{
   explosion = swingableSwordExplosion;
   uiName = "";
};


//Projectile
datablock ProjectileData(swingableSwordProjectile)
{
   directDamage        = 25;
   directDamageType    = $DamageType::Sword;
   radiusDamageType    = $DamageType::Sword;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 80;
   fadeDelay           = 40;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

//Item
datablock ItemData(swingableSwordItem : swordItem)
{
	shapeFile = "add-ons/weapon_sword/sword.dts";
	uiName = "Swingable Sword";
	colorShiftColor = "1 0.5 0.5 1";
	image = swingableSwordImage;
};

//Image
datablock ShapeBaseImageData(swingableSwordImage)
{
   // Basic Item properties
   shapeFile = "add-ons/weapon_sword/sword.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   correctMuzzleVector = false;
   className = "WeaponImage";

   item = swingableSwordItem;
   ammo = " ";
   projectile = swingableSwordProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;
   doRetraction = false;

   doColorShift = true;
   colorShiftColor = swingableSwordItem.colorShiftColor;

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "PreFire";
	stateSound[0]                   = swordDrawSound;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateTimeoutValue[2]            = 0.04;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "PreFire";
	stateTimeoutValue[3]            = 0.04;
	stateFire[3]                    = true;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
};

function swingableSwordImage::onFire(%this,%obj,%slot)
{	
	%player = %obj;
	%muz = %player.getMuzzleVector(0);
	%fwd = %player.getForwardVector();
	%muz = getWord(%muz,2);
	%fwd = getWord(%fwd,2);
	%med = -0.3;
	%isSwung = swungCheck(%player,%muz);
	if(%isSwung)
	{
	//	echo("muz =" SPC %muz);
		if(!%player.isFirstSwung && %muz > %med)
		{
			%player.isFirstSwung=1;
			schedule(800,0,eval,%player@".isFirstSwung=0;");
		}
	}
	%player.muz = %muz;
	%player.isSwung = %isSwung;
	parent::onFire(%this,%obj,%slot);
}
function swingableSwordProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	%player = %obj.sourceObject;
	if(%player.isFirstSwung && %player.isSwung)
	{
		parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
		makeSwordExplosion(%player,%pos);
	}
}
function swungCheck(%obj,%muz)
{
	%old = %obj.muz;
	%dist = vectorDist(%old,%muz);
//	echo("old =" SPC %old);
//	echo("dist =" SPC %dist);
	if(%dist > 0.05 && %old !$= "" && %old > %muz)
		return 1;
}
function makeSwordExplosion(%obj,%pos)
{
	if(isObject(%obj.sEx))
		%obj.sEx.delete();
	%sEx = new Projectile()
	{
		dataBlock = SwingableSwordExplosionProjectile;
		initialPosition = %pos;
		initialVelocity = %normal;
		sourceObject = %obj;
		client = %obj.client;
	};
	MissionCleanup.add(%sEx);
	%sEx.explode();
	%obj.sEx = %sEx;
}


function swingableSwordImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.setArmThread(armattack);
}
function swingableSwordImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	%obj.setArmThread(look);
}